package com.friday.custody.dao;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.friday.custody.entity.MjAccountBalanceInfoEntity;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 
 * 
 * @author lyb
 * @email k0051582@gmail.com
 * @date 2022-02-16 10:32:27
 */
@Mapper
public interface MjAccountBalanceInfoDao extends BaseMapper<MjAccountBalanceInfoEntity> {

    List<String> getBankAccoList(@Param("trustNo") String trustNo,
                                 @Param("admin") String admin);

    Map<String, String> queryMjFundPrt(@Param("admin") String admin, @Param("trustNo") String trustNo, @Param("bankAcco") String bankAcco);

    default Set<String> queryUniqueKeyList(List<String> uniqueKeyList){
        LambdaQueryWrapper<MjAccountBalanceInfoEntity> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.select(MjAccountBalanceInfoEntity::getUniqueKey).in(MjAccountBalanceInfoEntity::getUniqueKey, uniqueKeyList);
        List<MjAccountBalanceInfoEntity> entityList = this.selectList(queryWrapper);
        Set<String> result = entityList.stream().map(t -> t.getUniqueKey()).collect(Collectors.toSet());
        return result;
    }

    default int deleteByUniqueKeys(Set<String> uniqueKeySet){
        LambdaQueryWrapper<MjAccountBalanceInfoEntity> queryWrapper = new LambdaQueryWrapper();
        queryWrapper.in(MjAccountBalanceInfoEntity::getUniqueKey, uniqueKeySet);
        return delete(queryWrapper);
    }
}
